using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace BMA.EHR.Infrastructure.Migrations
{
    /// <inheritdoc />
    public partial class UpdatetablePlacementaddReportingDate : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_PlacementProfiles_PlacementStatuses_PlacementStatusId",
                table: "PlacementProfiles");

            migrationBuilder.DropTable(
                name: "PlacementStatuses");

            migrationBuilder.RenameColumn(
                name: "PlacementStatusId",
                table: "PlacementProfiles",
                newName: "GenderId");

            migrationBuilder.RenameIndex(
                name: "IX_PlacementProfiles_PlacementStatusId",
                table: "PlacementProfiles",
                newName: "IX_PlacementProfiles_GenderId");

            migrationBuilder.AddColumn<bool>(
                name: "IsRelief",
                table: "PlacementProfiles",
                type: "tinyint(1)",
                nullable: false,
                defaultValue: false,
                comment: "ผ่อนผัน");

            migrationBuilder.AddColumn<string>(
                name: "PlacementStatus",
                table: "PlacementProfiles",
                type: "longtext",
                nullable: true,
                comment: "สถานะการบรรจุ")
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.AddColumn<DateTime>(
                name: "ReportingDate",
                table: "PlacementProfiles",
                type: "datetime(6)",
                nullable: true,
                comment: "วันที่รายงานตัว");

            migrationBuilder.AddForeignKey(
                name: "FK_PlacementProfiles_Genders_GenderId",
                table: "PlacementProfiles",
                column: "GenderId",
                principalTable: "Genders",
                principalColumn: "Id");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropForeignKey(
                name: "FK_PlacementProfiles_Genders_GenderId",
                table: "PlacementProfiles");

            migrationBuilder.DropColumn(
                name: "IsRelief",
                table: "PlacementProfiles");

            migrationBuilder.DropColumn(
                name: "PlacementStatus",
                table: "PlacementProfiles");

            migrationBuilder.DropColumn(
                name: "ReportingDate",
                table: "PlacementProfiles");

            migrationBuilder.RenameColumn(
                name: "GenderId",
                table: "PlacementProfiles",
                newName: "PlacementStatusId");

            migrationBuilder.RenameIndex(
                name: "IX_PlacementProfiles_GenderId",
                table: "PlacementProfiles",
                newName: "IX_PlacementProfiles_PlacementStatusId");

            migrationBuilder.CreateTable(
                name: "PlacementStatuses",
                columns: table => new
                {
                    Id = table.Column<Guid>(type: "char(36)", nullable: false, comment: "PrimaryKey", collation: "ascii_general_ci"),
                    CreatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: false, comment: "สร้างข้อมูลเมื่อ"),
                    CreatedUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdatedAt = table.Column<DateTime>(type: "datetime(6)", nullable: true, comment: "แก้ไขข้อมูลล่าสุดเมื่อ"),
                    LastUpdateUserId = table.Column<string>(type: "varchar(40)", maxLength: 40, nullable: false, comment: "User Id ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    CreatedFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่สร้างข้อมูล")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    LastUpdateFullName = table.Column<string>(type: "varchar(200)", maxLength: 200, nullable: false, comment: "ชื่อ User ที่แก้ไขข้อมูลล่าสุด")
                        .Annotation("MySql:CharSet", "utf8mb4"),
                    IsActive = table.Column<bool>(type: "tinyint(1)", nullable: false, comment: "สถานะการใช้งาน"),
                    Name = table.Column<string>(type: "longtext", nullable: false, comment: "ชื่อสถานะบรรจุ")
                        .Annotation("MySql:CharSet", "utf8mb4")
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_PlacementStatuses", x => x.Id);
                })
                .Annotation("MySql:CharSet", "utf8mb4");

            migrationBuilder.AddForeignKey(
                name: "FK_PlacementProfiles_PlacementStatuses_PlacementStatusId",
                table: "PlacementProfiles",
                column: "PlacementStatusId",
                principalTable: "PlacementStatuses",
                principalColumn: "Id");
        }
    }
}
